'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _lodash = require('lodash');var _lodash2 = _interopRequireDefault(_lodash);
var _assert = require('assert');var _assert2 = _interopRequireDefault(_assert);
var _debug = require('debug');var _debug2 = _interopRequireDefault(_debug);
var _events = require('events');
var _bluebird = require('bluebird');var _bluebird2 = _interopRequireDefault(_bluebird);
var _bull = require('bull');var _bull2 = _interopRequireDefault(_bull);

var _redis_store = require('./redis_store');var _redis_store2 = _interopRequireDefault(_redis_store);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _asyncToGenerator(fn) {return function () {var gen = fn.apply(this, arguments);return new _bluebird2.default(function (resolve, reject) {function step(key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {return _bluebird2.default.resolve(value).then(function (value) {step("next", value);}, function (err) {step("throw", err);});}}return step("next");});};}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

var debug = (0, _debug2.default)('abul');var

Abul = function (_EventEmitter) {_inherits(Abul, _EventEmitter);
  function Abul(opts) {_classCallCheck(this, Abul);


    // 参数校验
    var _this = _possibleConstructorReturn(this, (Abul.__proto__ || Object.getPrototypeOf(Abul)).call(this));_assert2.default.equal(typeof opts.handler, 'function');
    _assert2.default.equal(typeof opts.connectionString === 'string' || opts.connectionString === undefined, true);
    _assert2.default.equal(typeof opts.concurrency === 'number' || opts.concurrency === undefined, true);

    // 需要外部配置的参数
    // 队列处理器
    _this.handler = opts.handler;

    // Queue create的参数
    _this.connectionString = opts.connectionString;

    // 队列并发数
    _this.concurrency = opts.concurrency || 5;

    // 记录正在运行的任务数据库
    _this.runningDbName = opts.runningDbName || 'abul';

    ////////////////////////////////////////////////////////////////////////////////////////////////
    // 内部数据结构，不是参数
    ////////////////////////////////////////////////////////////////////////////////////////////////
    // 进程中记录的正在运行的任务
    // key    taskname任务名称，key必须是唯一的
    // value  任务队列实例
    _this.runningTask = {};

    _this.redis = new _redis_store2.default({ redis: _this.connectionString, runningDbName: _this.runningDbName });

    // 定时加载正在运行的任务
    Abul.runningTick(_this);
    setInterval(Abul.runningTick(_this), 5000);return _this;
  }

  /**
     * 定时从DB中加载正在运行的任务，并和当前进程中记录的正在运行的任务做DIFF
     * 如果任务已经完成，那么关闭当前进程中正在运行的任务
     * 如果是新任务，那么在当前进程中添加处理
     * @param {*} self
     * @private
     */_createClass(Abul, [{ key: 'cleanOldJobQueue',

























    /**
                                                       * 清理已完成任务
                                                       * @private
                                                       */value: function () {var _ref = _asyncToGenerator(function* (
      finishTaskNames) {var _this2 = this;
        debug('CLEAN_OLD_TASK', finishTaskNames);

        yield _bluebird2.default.each(finishTaskNames, function () {var _ref2 = _asyncToGenerator(function* (oldTaskName) {
            debug('CLEAN_OLD_TASK_START', oldTaskName);

            // 清空任务
            yield _this2.runningTask[oldTaskName].empty();

            // 关闭worker
            yield _this2.runningTask[oldTaskName].close(true);

            // 清理任务运行数据

            // 删除当前进程里的任务记录
            delete _this2.runningTask[oldTaskName];

            debug('CLEAN_OLD_TASK_SUCCESS', oldTaskName);
          });return function (_x2) {return _ref2.apply(this, arguments);};}());
      });function cleanOldJobQueue(_x) {return _ref.apply(this, arguments);}return cleanOldJobQueue;}()

    /**
                                                                                                         * 初始化新增的任务
                                                                                                         * @private
                                                                                                         */ }, { key: 'initNewJobQueue', value: function () {var _ref3 = _asyncToGenerator(function* (
      newTaskNames) {var _this3 = this;
        debug('NEW_TASKS', newTaskNames);

        yield _bluebird2.default.each(newTaskNames, function () {var _ref4 = _asyncToGenerator(function* (newTaskName) {
            debug('NEW_TASK_START', newTaskName);

            // 开始准备处理该类型的任务
            yield _this3.ready(newTaskName, false);

            debug('NEW_TASK_FINISH', newTaskName);
          });return function (_x4) {return _ref4.apply(this, arguments);};}());
      });function initNewJobQueue(_x3) {return _ref3.apply(this, arguments);}return initNewJobQueue;}()

    /**
                                                                                                         * 检查任务是否完成
                                                                                                         * @param {string} taskName
                                                                                                         * @param {object} status
                                                                                                         * @param {object} queue
                                                                                                         * @private
                                                                                                         */ }, { key: 'startDoneChecker', value: function () {var _ref5 = _asyncToGenerator(function* (
      taskName, queue) {
        debug('startDoneChecker');
        var status = yield queue.getJobCounts();
        var taskInfo = yield this.redis.getRunning(taskName);

        debug('StartDoneCheckerResult', taskName, status, taskInfo);

        if (!taskInfo || !status) return;

        // 如果几种类型的任务都为不0，那么任务肯定没完成，不再进行详细的检测
        if (status.waiting !== 0 || status.delayed !== 0 || status.active !== 0) {
          return;
        }

        if (taskInfo.status !== 'final') {
          return;
        }

        var stats = (yield this.redis.getStats(taskName)) || {};

        // 再次检测几种类型的任务是否为0，并且任务是否已经很久没有添加
        this.emit('done', taskName, stats);

        yield this.redis.delRunning(taskName);
        debug('TASK_IS_DONE', taskName);
      });function startDoneChecker(_x5, _x6) {return _ref5.apply(this, arguments);}return startDoneChecker;}()

    /**
                                                                                                                * 准备开始一个推送任务
                                                                                                                * @param {string} newTaskName
                                                                                                                * @public
                                                                                                                */ }, { key: 'ready', value: function () {var _ref6 = _asyncToGenerator(function* (
      newTaskName) {var _this4 = this;var isNew = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var queue = this.runningTask[newTaskName];

        // 如果已经存在，那么不再重复创建
        if (queue) {
          return;
        }

        // 创建任务队列worker
        queue = new _bull2.default(newTaskName, this.connectionString);

        // 重新emit事件类型，增加task name参数为第一个参数
        _lodash2.default.each([
        'global:ready',
        'global:error',
        'global:active',
        'global:stalled',
        'global:progress',
        'global:completed',
        'global:failed',
        'global:paused',
        'global:resumed',
        'global:cleaned',
        'ready',
        'error',
        'active',
        'stalled',
        'progress',
        'completed',
        'failed',
        'paused',
        'resumed',
        'cleaned'],
        function (eventName) {
          queue.on(eventName, function () {var _ref7 = _asyncToGenerator(function* () {for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}
              debug(`QUEUE EVENT:${eventName}`, newTaskName);

              args.unshift(newTaskName);
              args.unshift(eventName);

              if (eventName === 'active') {
                yield _this4.redis.setStats(newTaskName, 'total');
              } else if (eventName === 'completed') {
                yield _this4.redis.setStats(newTaskName, 'success');
              } else if (eventName === 'failed') {
                yield _this4.redis.setStats(newTaskName, 'failed');
              }

              // 检测任务是否全部完成
              if (eventName === 'completed' || eventName === 'failed') {
                yield _this4.startDoneChecker(newTaskName, queue);
              }

              _this4.emit.apply(_this4, args);
            });return function () {return _ref7.apply(this, arguments);};}());
        });

        // 设置任务处理器
        queue.process(this.concurrency, this.handler);

        // 保存到当前进程的任务记录
        this.runningTask[newTaskName] = queue;

        // 保存到正在运行的任务记录中
        if (isNew) {
          yield this.redis.setRunning(newTaskName, { status: 'ready', start: Date.now() });
        }

        process.nextTick(function () {
          _this4.emit('ready', newTaskName);
        });
      });function ready(_x7) {return _ref6.apply(this, arguments);}return ready;}()

    /**
                                                                                     *  结束添加任务
                                                                                     * @param {string} taskName
                                                                                     */ }, { key: 'final', value: function () {var _ref8 = _asyncToGenerator(function* (
      taskName) {
        var ret = yield this.redis.setRunning(taskName, { status: 'final' });
        return ret;
      });function final(_x9) {return _ref8.apply(this, arguments);}return final;}()

    /**
                                                                                     * 向一个任务队列中增加任务，使用name做为队列名称，唯一不重复
                                                                                     * 重试3次
                                                                                     * 每次回退10秒
                                                                                     * 任务时间1分钟
                                                                                     * 完成后自动删除任务，减少内存占用
                                                                                     * @public
                                                                                     */ }, { key: 'add', value: function () {var _ref9 = _asyncToGenerator(function* (
      name, task, options) {
        _assert2.default.equal(typeof name, 'string');
        _assert2.default.equal(typeof task, 'object');
        _assert2.default.equal(typeof options === 'object' || options === undefined, true);

        debug('READY_TO_ADD_TASK', name, task, options);
        var queue = this.runningTask[name];

        if (!queue) {
          throw new Error(`Job [${name}] is not running!`);
        }

        return queue.add(task, _lodash2.default.defaults(options, {
          attempts: 3,
          timeout: 60 * 1000,
          removeOnFail: true,
          removeOnComplete: true,
          backoff: {
            type: 'fixed',
            delay: 10 * 1000 } }));


      });function add(_x10, _x11, _x12) {return _ref9.apply(this, arguments);}return add;}() }], [{ key: 'runningTick', value: function runningTick(self) {return _asyncToGenerator(function* () {debug('--------------------------- LOAD TICK START---------------------------'); // 最新的正在运行的任务
        var runningTaskNow = yield self.redis.getRunnings();var runningTaskNowNames = _lodash2.default.keys(runningTaskNow); // 当前进程中记录的正在运行的任务
        var runningOldTaskNames = _lodash2.default.keys(self.runningTask);debug('RunningTick', 'DB RUNNING:', runningTaskNowNames, 'PROCESS RUNNING:', runningOldTaskNames); // 清理已完成任务
        var finishTaskNames = _lodash2.default.differenceBy(_lodash2.default.keys(self.runningTask), runningTaskNowNames);yield self.cleanOldJobQueue(finishTaskNames); // 新任务开始响应
        var newTaskNames = _lodash2.default.differenceBy(runningTaskNowNames, _lodash2.default.keys(self.runningTask));yield self.initNewJobQueue(newTaskNames);debug('--------------------------- LOAD TICK FINISH---------------------------');});} }]);return Abul;}(_events.EventEmitter);exports.default = Abul;