'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _lodash = require('lodash');var _lodash2 = _interopRequireDefault(_lodash);
var _ioredis = require('ioredis');var _ioredis2 = _interopRequireDefault(_ioredis);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _asyncToGenerator(fn) {return function () {var gen = fn.apply(this, arguments);return new Promise(function (resolve, reject) {function step(key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {return Promise.resolve(value).then(function (value) {step("next", value);}, function (err) {step("throw", err);});}}return step("next");});};}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}var

RedisStore = function () {
  function RedisStore(opts) {_classCallCheck(this, RedisStore);
    this.dbName = opts.runningDbName || 'running_task_info';
    this.client = new _ioredis2.default(opts.redis);
  }

  /**
     * 获取正在运行的所有任务
     * @returns null | {}
     */_createClass(RedisStore, [{ key: 'getRunnings', value: function () {var _ref = _asyncToGenerator(function* ()
      {
        var raws = yield this.client.hgetall(this.dbName);
        var runnings = _lodash2.default.mapValues(raws, function (raw, key) {
          try {
            return JSON.parse(raw);
          } catch (error) {
            console.error(error);
            return null;
          }
        });

        runnings = _lodash2.default.omitBy(runnings, function (value, key) {
          return _lodash2.default.endsWith(key, ':total') || _lodash2.default.endsWith(key, ':success') || _lodash2.default.endsWith(key, ':failed');
        });

        return runnings;
      });function getRunnings() {return _ref.apply(this, arguments);}return getRunnings;}()

    /**
                                                                                             * 获取任务信息
                                                                                             * @param {string} taskId
                                                                                             * @returns null | {}
                                                                                             */ }, { key: 'getRunning', value: function () {var _ref2 = _asyncToGenerator(function* (
      taskId) {
        var raw = yield this.client.hget(this.dbName, taskId);
        try {
          return JSON.parse(raw);
        } catch (error) {
          console.error(error);
          return null;
        }
      });function getRunning(_x) {return _ref2.apply(this, arguments);}return getRunning;}()

    /**
                                                                                              * 删除任务
                                                                                              * @param {string} taskId
                                                                                              * @returns 0 | 1
                                                                                              */ }, { key: 'delRunning', value: function () {var _ref3 = _asyncToGenerator(function* (
      taskId) {
        var ret = yield this.client.hdel(this.dbName, taskId);
        return ret;
      });function delRunning(_x2) {return _ref3.apply(this, arguments);}return delRunning;}()

    /**
                                                                                               * 更新任务信息
                                                                                               * @param {string} taskId
                                                                                               * @param {object} data
                                                                                               * @returns 0 | 1
                                                                                               */ }, { key: 'setRunning', value: function () {var _ref4 = _asyncToGenerator(function* (
      taskId, data) {
        var oldRaw = yield this.client.hget(this.dbName, taskId);
        var old = null;
        try {
          old = JSON.parse(oldRaw);
        } catch (error) {
          console.error(error);
          old = {};
        }

        var newData = JSON.stringify(_lodash2.default.merge({}, old, data));
        var ret = yield this.client.hset(this.dbName, taskId, newData);

        return ret;
      });function setRunning(_x3, _x4) {return _ref4.apply(this, arguments);}return setRunning;}() }, { key: 'setStats', value: function () {var _ref5 = _asyncToGenerator(function* (

      taskId, status) {
        var ret = yield this.client.hincrby(this.dbName, `${taskId}:${status}`, 1);
        return ret;
      });function setStats(_x5, _x6) {return _ref5.apply(this, arguments);}return setStats;}() }, { key: 'getStats', value: function () {var _ref6 = _asyncToGenerator(function* (

      taskId) {
        var rets = yield this.client.
        multi().
        hget(this.dbName, `${taskId}:total`).
        hget(this.dbName, `${taskId}:success`).
        hget(this.dbName, `${taskId}:failed`).
        exec();

        return {
          total: _lodash2.default.get(rets, '0.1', 0) || 0,
          success: _lodash2.default.get(rets, '1.1', 0) || 0,
          failed: _lodash2.default.get(rets, '2.1', 0) || 0 };

      });function getStats(_x7) {return _ref6.apply(this, arguments);}return getStats;}() }]);return RedisStore;}();exports.default = RedisStore;